## coq-doc 8.1

=== Makefile ===
# Makefile for the Coq documentation

# COQTOP needs to be set to a coq source repository

# To compile documentation, you need the following tools:
# Dvi: latex (latex2e), bibtex, makeindex
# Pdf: pdflatex
# Html: hevea (http://hevea.inria.fr) >= 1.05

include ../config/Makefile


LATEX=latex
BIBTEX=bibtex -min-crossrefs=10
MAKEINDEX=makeindex
PDFLATEX=pdflatex

HEVEALIB=/usr/local/lib/hevea:/usr/lib/hevea
TEXINPUTS=$(HEVEALIB):.:

DOCCOQTOP=$(COQTOP)/bin/coqtop
COQTEX=$(COQTOP)/bin/coq-tex -n 72 -image $(DOCCOQTOP) -v -sl -small
COQDOC=$(COQTOP)/bin/coqdoc

#VERSION=POSITIONNEZ-CETTE-VARIABLE

######################################################################
### General rules
######################################################################

all: all-html all-pdf all-ps

all-html:\
  tutorial/Tutorial.v.html refman/html/index.html \
  faq/html/index.html stdlib/html/index.html RecTutorial/RecTutorial.v.html

all-pdf:\
  tutorial/Tutorial.v.pdf refman/Reference-Manual.pdf \
  faq/FAQ.v.pdf stdlib/Library.pdf RecTutorial/RecTutorial.v.pdf

all-ps:\
  tutorial/Tutorial.v.ps refman/Reference-Manual.ps \
  faq/FAQ.v.ps stdlib/Library.ps RecTutorial/RecTutorial.v.ps

refman:\
  refman/html/index.html refman/Reference-Manual.ps refman/Reference-Manual.pdf

tutorial:\
  tutorial/Tutorial.v.html tutorial/Tutorial.v.ps tutorial/Tutorial.v.pdf

stdlib:\
  stdlib/html/index.html stdlib/Library.ps stdlib/Library.pdf

faq:\
  faq/html/index.html faq/FAQ.v.ps faq/FAQ.v.pdf

rectutorial:\
  RecTutorial/RecTutorial.v.html \
  RecTutorial/RecTutorial.v.ps RecTutorial/RecTutorial.v.pdf

######################################################################
### Implicit rules
######################################################################

.SUFFIXES: .dvi .tex .v.tex .ps .pdf .eps .png

%.v.tex: %.tex
	(cd `dirname $<`; $(COQTEX) `basename $<`)

%.ps: %.dvi
	(cd `dirname $<`; dvips -o `basename $@` `basename $<`)

%.eps: %.png
	pngtopnm $< | pnmtops -equalpixels -noturn -rle > $@

clean:
	rm -f */*.dvi */*.aux */*.log */*.bbl */*.blg */*.toc \
	*/*.idx */*~ */*.ilg */*.ind */*.dvi.gz */*.ps.gz */*.pdf.gz\
	*/*.???idx */*.???ind */*.v.tex */*.atoc */*.lof\
	*/*.hatoc */*.haux */*.hcomind */*.herrind */*.hidx */*.hind \
	*/*.htacind */*.htoc */*.v.html
	rm -f stdlib/index-list.html stdlib/index-body.html \
	  stdlib/Library.coqdoc.tex stdlib/library.files \
	  stdlib/library.files.ls
	rm -f refman/euclid.ml{,i} refman/heapsort.ml{,i}
	rm -f common/version.tex
	rm -f refman/*.eps refman/Reference-Manual.html

cleanall: clean
	rm -f */*.ps */*.pdf
	rm -rf refman/html stdlib/html faq/html tutorial/tutorial.v.html

######################################################################
# Common
######################################################################

COMMON=common/version.tex common/title.tex common/macros.tex 

### Version

common/version.tex: Makefile
	echo "\newcommand{\coqversion}{$(VERSION)}" > common/version.tex

######################################################################
# Reference Manual
######################################################################

REFMANCOQTEXFILES=\
  refman/RefMan-gal.v.tex refman/RefMan-ext.v.tex \
  refman/RefMan-mod.v.tex refman/RefMan-tac.v.tex \
  refman/RefMan-cic.v.tex refman/RefMan-lib.v.tex \
  refman/RefMan-tacex.v.tex refman/RefMan-syn.v.tex \
  refman/RefMan-oth.v.tex refman/RefMan-ltac.v.tex \
  refman/Cases.v.tex refman/Coercion.v.tex refman/Extraction.v.tex \
  refman/Program.v.tex refman/Omega.v.tex refman/Polynom.v.tex \
  refman/Setoid.v.tex refman/Helm.tex # refman/Natural.v.tex

REFMANTEXFILES=\
  refman/headers.tex \
  refman/Reference-Manual.tex refman/RefMan-pre.tex \
  refman/RefMan-int.tex refman/RefMan-pro.tex \
  refman/RefMan-com.tex \
  refman/RefMan-uti.tex refman/RefMan-ide.tex \
  refman/RefMan-add.tex refman/RefMan-modr.tex \
  $(REFMANCOQTEXFILES) \

REFMANEPSFILES= refman/coqide.eps refman/coqide-queries.eps

REFMANFILES=\
  $(REFMANTEXFILES) $(COMMON) $(REFMANEPSFILES) refman/biblio.bib

REFMANPNGFILES=$(REFMANEPSFILES:.eps=.png)

### Reference Manual (printable format)

# The second LATEX compilation is necessary otherwise the pages of the index
# are not correct (don't know why...) - BB
refman/Reference-Manual.dvi: $(REFMANFILES)
	(cd refman;\
	$(LATEX) Reference-Manual;\
	$(BIBTEX) Reference-Manual;\
	$(LATEX) Reference-Manual;\
	$(MAKEINDEX) Reference-Manual;\
	$(MAKEINDEX) Reference-Manual.tacidx -o Reference-Manual.tacind;\
	$(MAKEINDEX) Reference-Manual.comidx -o Reference-Manual.comind;\
	$(MAKEINDEX) Reference-Manual.erridx -o Reference-Manual.errind;\
	$(LATEX) Reference-Manual;\
	$(LATEX) Reference-Manual)

refman/Reference-Manual.pdf: refman/Reference-Manual.tex
	(cd refman; $(PDFLATEX) Reference-Manual.tex)

### Reference Manual (browsable format)

refman/Reference-Manual.html: refman/Reference-Manual.dvi # to ensure bbl file
	(cd refman; hevea -fix -exec xxdate.exe ./Reference-Manual.tex)

refman/html/index.html: refman/Reference-Manual.html $(REFMANPNGFILES) \
                        refman/cover.html refman/index.html
	- rm -rf refman/html
	mkdir refman/html
	cp $(REFMANPNGFILES) refman/html
	(cd refman/html; hacha -o toc.html ../Reference-Manual.html)
	cp refman/cover.html refman/menu.html refman/html
	cp refman/index.html refman/html

refman-quick:
	(cd refman; \
	 $(PDFLATEX) Reference-Manual.tex; \
	 hevea -fix -exec xxdate.exe ./Reference-Manual.tex)


######################################################################
# Tutorial
######################################################################

tutorial/Tutorial.v.dvi: common/version.tex common/title.tex tutorial/Tutorial.v.tex
	(cd tutorial; $(LATEX) Tutorial.v)

tutorial/Tutorial.v.pdf: common/version.tex common/title.tex tutorial/Tutorial.v.dvi
	(cd tutorial; $(PDFLATEX) Tutorial.v.tex)

tutorial/Tutorial.v.html: tutorial/Tutorial.v.tex
	(cd tutorial; hevea -exec xxdate.exe Tutorial.v)


######################################################################
# FAQ
######################################################################

faq/FAQ.v.dvi: common/version.tex common/title.tex faq/FAQ.v.tex
	(cd faq;\
	$(LATEX) FAQ.v;\
	$(BIBTEX) FAQ.v;\
	$(LATEX) FAQ.v;\
	$(LATEX) FAQ.v)

faq/FAQ.v.pdf: common/version.tex common/title.tex faq/FAQ.v.dvi faq/axioms.png
	(cd faq; $(PDFLATEX) FAQ.v.tex)

faq/FAQ.v.html: faq/FAQ.v.dvi # to ensure FAQ.v.bbl
	(cd faq; hevea -fix FAQ.v.tex)

faq/html/index.html: faq/FAQ.v.html
	- rm -rf faq/html
	mkdir faq/html
	cp faq/interval_discr.v faq/axioms.png faq/html
	cp faq/FAQ.v.html faq/html/index.html

######################################################################
# Standard library
######################################################################

GLOBDUMP=$(COQTOP)/glob.dump

LIBDIRS= Logic Bool Arith ZArith QArith Reals Lists Sets Relations Sorting Wellfounded IntMap FSets

### Standard library (browsable html format)

stdlib/index-body.html: $(GLOBDUMP)
	- rm -rf stdlib/html
	mkdir stdlib/html
	(cd stdlib/html;\
	 $(COQDOC) -q --multi-index --html --glob-from $(GLOBDUMP)\
	  -R $(COQTOP)/theories Coq $(COQTOP)/theories/*/*.v)
	mv stdlib/html/index.html stdlib/index-body.html

stdlib/index-list.html: stdlib/index-list.html.template
	COQTOP=$(COQTOP) ./stdlib/make-library-index stdlib/index-list.html

stdlib/html/index.html: stdlib/index-list.html stdlib/index-body.html stdlib/index-trailer.html
	cat stdlib/index-list.html > $@
	sed -n -e '/<table>/,/<\/table>/p' stdlib/index-body.html >> $@
	cat stdlib/index-trailer.html >> $@

### Standard library (printable format - produces > 350 pages)

stdlib/Library.coqdoc.tex: 
	(for dir in $(LIBDIRS) ; do \
	  $(COQDOC) -q --gallina --body-only --latex --stdout \
	    --coqlib_path $(COQTOP) \
            -R $(COQTOP)/theories Coq "$(COQTOP)/theories/$$dir/"*.v >> $@ ; done)

stdlib/Library.dvi: $(COMMON) stdlib/Library.coqdoc.tex stdlib/Library.tex
	(cd stdlib;\
	$(LATEX) Library;\
	$(LATEX) Library)

stdlib/Library.pdf: $(COMMON) stdlib/Library.coqdoc.tex stdlib/Library.dvi
	(cd stdlib; $(PDFLATEX) Library)

######################################################################
# Tutorial on inductive types
######################################################################

RecTutorial/RecTutorial.v.dvi: common/version.tex common/title.tex RecTutorial/RecTutorial.v.tex
	(cd RecTutorial;\
	 $(LATEX) RecTutorial.v;\
	 $(BIBTEX) RecTutorial.v;\
	 $(LATEX) RecTutorial.v;\
	 $(LATEX) RecTutorial.v)

RecTutorial/RecTutorial.v.pdf: common/version.tex common/title.tex RecTutorial/RecTutorial.v.dvi
	(cd RecTutorial; $(PDFLATEX) RecTutorial.v.tex)

RecTutorial/RecTutorial.v.html: RecTutorial/RecTutorial.v.tex
	(cd RecTutorial; hevea -exec xxdate.exe RecTutorial.v)


######################################################################
# Install all documentation files
######################################################################

COQINSTALLPREFIX=
DOCDIR=/usr/local/share/doc/coq-8.0
FULLDOCDIR=$(COQINSTALLPREFIX)$(DOCDIR)
HTMLINSTALLDIR=$(FULLDOCDIR)/html
PRINTABLEINSTALLDIR=$(FULLDOCDIR)/ps

install-doc: install-meta install-doc-html install-doc-printable

install-meta:
	mkdir $(DOCDIC)
	cp LICENCE $(DOCDIC)/LICENCE.doc
#	cp $(COQTOP)/LICENCE $(COQTOP)/CREDITS $(COQTOP)/COPYRIGHT $(DOCDIC)
#	cp $(COQTOP)/README $(COQTOP)/CHANGES $(DOCDIC)

install-doc-html: all-html
	mkdir $(HTMLINSTALLDIR)
	cp -r refman/html $(HTMLINSTALLDIR)/refman
	cp -r stdlib/html $(HTMLINSTALLDIR)/stdlib
	cp -r tutorial/tutorial.html $(HTMLINSTALLDIR)/
	cp -r RecTutorial/RecTutorial.html $(HTMLINSTALLDIR)/
	cp -r faq/html $(HTMLINSTALLDIR)/faq

install-doc-printable: all-pdf all-ps
	mkdir $(PRINTABLEINSTALLDIR)
	cp -r refman/Reference-manual.pdf $(PRINTABLEINSTALLDIR)
	cp -r stdlib/Library.pdf $(PRINTABLEINSTALLDIR)
	cp -r tutorial/Tutorial.v.pdf $(PRINTABLEINSTALLDIR)/Tutorial.pdf
	cp -r RecTutorial/RecTutorial.v.pdf $(PRINTABLEINSTALLDIR)/RecTutorial.pdf
	cp -r faq/FAQ.v.pdf $(PRINTABLEINSTALLDIR)/FAQ.pdf
	cp -r refman/Reference-manual.ps $(PRINTABLEINSTALLDIR)
	cp -r stdlib/Library.ps $(PRINTABLEINSTALLDIR)
	cp -r tutorial/Tutorial.v.ps $(PRINTABLEINSTALLDIR)/Tutorial.ps
	cp -r RecTutorial/RecTutorial.v.ps $(PRINTABLEINSTALLDIR)/RecTutorial.ps
	cp -r faq/FAQ.v.ps $(PRINTABLEINSTALLDIR)/FAQ.ps

## coq-doc 8.2pl1

=== debian/changelog ===
coq-doc (8.2pl1-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * New upstream release (Closes: #563669)
    - remove patches
  * Packaging overhaul:
    - use git, advertise it in Vcs-* fields of debian/control
    - use debhelper 7 and dh with override
    - use source format 3.0 (quilt)
  * debian/control:
    - set Maintainer to d-o-m, set Uploaders to Sam and myself
    - add Homepage field
    - bump Standards-Version to 3.8.3
  * Register PDF documentation into doc-base
  * Add debian/watch
  * Update debian/copyright

  [ Samuel Mimram ]
  * Change coq-doc's description to mention that it provides documentation in
    pdf format, not postscript, closes: #543545.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 07 Jan 2010 22:50:39 +0100

coq-doc (8.1-3) unstable; urgency=low

  * Removed tetex-bin from build-dependencies, and added texlive-base,
    texlive-latex-extra, texlive-math-extra, texlive-lang-french and
    texlive-humanities, closes: #420591.

 -- Samuel Mimram <smimram@debian.org>  Sat, 14 Apr 2007 18:24:43 +0200

coq-doc (8.1-2) unstable; urgency=low

  * Uploading to unstable.

 -- Samuel Mimram <smimram@debian.org>  Mon, 09 Apr 2007 17:21:10 +0200

coq-doc (8.1-1) experimental; urgency=low

  * New upstream release.
  * Allow building with texlive in build-dependencies.

 -- Samuel Mimram <smimram@debian.org>  Tue, 13 Feb 2007 13:23:18 +0000

coq-doc (8.1~gamma-2) experimental; urgency=low

  * Correctly install html documentation, closes: #407117.

 -- Samuel Mimram <smimram@debian.org>  Tue, 16 Jan 2007 17:40:02 +0000

coq-doc (8.1~gamma-1) experimental; urgency=low

  * New upstream release.
  * Added faq-urldef.dpatch to workaround hevea bug #405994.

 -- Samuel Mimram <smimram@debian.org>  Sun,  7 Jan 2007 20:18:31 +0100

coq-doc (8.0pl3+8.1beta.2-1) experimental; urgency=low

  * New beta upstream release.

 -- Samuel Mimram <smimram@debian.org>  Thu, 13 Jul 2006 14:40:04 +0000

coq-doc (8.0pl3+8.1alpha-2) experimental; urgency=low

  * Correct a typo in coq-rectutorial's doc-base (thanks Remi Vanicat),
    closes: #366611.
  * Updated standards version to 3.7.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Wed, 10 May 2006 16:39:24 +0000

coq-doc (8.0pl3+8.1alpha-1) experimental; urgency=low

  * The licensing issue is now solved. The new licence is OPL which is not
    DFSG-compatible. We're moving to non-free, closes: #294865.
  * Updated the copyright file.
  * Split coq-doc into -html and -pdf, closes: #266019.
  * Using dpatch for handling patches.
  * Updated standards version to 3.6.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Fri, 28 Apr 2006 18:52:06 +0200

coq-doc (8.0pl1.0-1) unstable; urgency=low

  * Added the Coq faq, moved the tutorial to the root directory and added
    doc-base files for both, closes: #272204.
  * Set dh_compat to level 4.

 -- Samuel Mimram <samuel.mimram@ens-lyon.org>  Sat, 18 Sep 2004 13:28:22 +0200

coq-doc (8.0pl1-1) unstable; urgency=medium

  * New maintainer.
  * New upstream release, closes: #265077.
  * Converted changelog and control to utf8.
  * Updated Standards-Version to 3.6.1.
  * Removed the unneeded Depends.
  * Added a symbolic link to the documentation in /usr/share/doc/coq,
    closes: #146617.
  * Included the html documentation, closes: #146618.
  * Slightly modified the description, since we now also have the html doc.
  * The package is now built by the binary-indep rule of debian/rules.

 -- Samuel Mimram <samuel.mimram@ens-lyon.org>  Fri, 13 Aug 2004 16:32:10 +0200

coq-doc (7.2-1) unstable; urgency=medium

  * New upstream version.
  * New maintainer.

 -- Judicaël Courant <Judicael.Courant@lri.fr>  Thu, 18 Apr 2002 15:08:00 +0200

coq-doc (6.3.1-2) unstable; urgency=low

  * Changed Architecture field from 'any' to 'all' since this package only
    contains documentation (closes: Bug#52770)

 -- Fernando Sanchez <fer@debian.org>  Sat, 18 Dec 1999 12:43:48 +0100

coq-doc (6.3.1-1) unstable; urgency=low

  * New upstream release

 -- Fernando Sanchez <fer@debian.org>  Wed,  8 Dec 1999 16:19:01 +0100

coq-doc (6.3-1) unstable; urgency=low

  * Initial Release.

 -- Fernando Sanchez <fer@debian.org>  Sun, 28 Nov 1999 19:42:06 +0100

=== debian/control ===
Source: coq-doc
Section: non-free/doc
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Samuel Mimram <smimram@debian.org>,
 Stéphane Glondu <glondu@debian.org>
Standards-Version: 3.8.3
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep:
 texlive,
 texlive-base,
 texlive-latex-extra,
 texlive-math-extra,
 texlive-lang-french,
 texlive-humanities,
 hevea (>= 1.05),
 camlp5,
 ocaml-nox
Homepage: http://coq.inria.fr/
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/coq-doc.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/coq-doc.git

Package: coq-doc
Architecture: all
Depends: coq-doc-html, coq-doc-pdf, ${misc:Depends}
Description: documentation for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This is a dummy package which will install the documentation in html and
 pdf formats.

Package: coq-doc-html
Architecture: all
Depends: ${misc:Depends}
Replaces: coq-doc (<= 8.0pl1.0-1)
Description: documentation for Coq in html format
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package contains its documentation and tutorials in html format.

Package: coq-doc-pdf
Architecture: all
Depends: ${misc:Depends}
Replaces: coq-doc (<= 8.0pl1.0-1)
Description: documentation for Coq in pdf format
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package contains its documentation and tutorials in pdf format.

## coq-doc 8.3pl2

=== debian/changelog ===
coq-doc (8.3pl2-1build1) precise; urgency=low

  * No-change rebuild against current pkgbinarymangler to fix broken
    md5sums. (see LP #875466)

 -- Felix Geyer <debfx@ubuntu.com>  Fri, 02 Mar 2012 18:31:49 +0100

coq-doc (8.3pl2-1) unstable; urgency=low

  * New upstream release
  * Make dependencies of coq-doc versioned
  * Bump debhelper compat level to 8
  * Bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Fri, 06 May 2011 10:36:59 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Uploaders:
  Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 3.8.3
-Build-Depends: debhelper (>= 7.0.50~)
+Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8)
 Build-Depends-Indep:
  texlive,
  texlive-base,
@@ -23,7 +23,10 @@
 
 Package: coq-doc
 Architecture: all
-Depends: coq-doc-html, coq-doc-pdf, ${misc:Depends}
+Depends:
+ coq-doc-html (>= ${source:Version}),
+ coq-doc-pdf (>= ${source:Version}),
+ ${misc:Depends}
 Description: documentation for Coq
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal

## coq-doc 8.3pl3

=== debian/changelog ===
coq-doc (8.3pl3-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Jan 2012 23:42:48 +0100

## coq-doc 8.3pl4

=== debian/changelog ===
coq-doc (8.3pl4-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 06 Apr 2012 07:33:19 +0200

## coq-doc 8.4pl2

=== test-suite/Makefile ===
#######################################################################
#  v      #   The Coq Proof Assistant  /  The Coq Development Team    #
# <O___,, #     INRIA-Rocquencourt  &  CNRS-Universite Paris Diderot  #
#   \VV/  #############################################################
#    //   #      This file is distributed under the terms of the      #
#         #       GNU Lesser General Public License Version 2.1       #
#######################################################################

# This is a standalone Makefile to run the test-suite. It can be used
# outside of the Coq source tree (if BIN is overridden).

# There is one %.v.log target per %.v test file. The target will be
# filled with the output, timings and status of the test. There is
# also one target per directory containing %.v files, that runs all
# the tests in it. As convenience, there is also the "bugs" target
# that runs all bug-related tests.

# The "summary" target outputs a summary of all tests that were run
# (but doesn't run them)

# The "run" target runs all tests that have not been run yet. To force
# all tests to be run, use the "clean" target.

#######################################################################
# Variables
#######################################################################

# Default value when called from a freshly compiled Coq, but can be
# easily overridden
BIN := ../bin/
LIB := ..

ifeq ($(BEST),byte)
  coqtop := $(BIN)coqtop.byte -boot -q -batch -I prerequisite
  bincoqc := $(BIN)coqc -coqlib $(LIB) -byte -I prerequisite
else
  coqtop := $(BIN)coqtop -boot -q -batch -I prerequisite
  bincoqc := $(BIN)coqc -coqlib $(LIB) -I prerequisite
endif

command := $(coqtop) -top Top -load-vernac-source
coqc := $(coqtop) -compile
coqdep := $(BIN)coqdep -coqlib $(LIB)

SHOW := $(if $(VERBOSE),@true,@echo)
HIDE := $(if $(VERBOSE),,@)
REDIR := $(if $(VERBOSE),,> /dev/null 2>&1)

ifneq (,$(wildcard /proc/cpuinfo))
  sedbogo := -e "s/bogomips.*: \([0-9]*\).*/\1/p" # i386, ppc
  sedbogo += -e "s/Cpu0Bogo.*: \([0-9]*\).*/\1/p" # sparc
  sedbogo += -e "s/BogoMIPS.*: \([0-9]*\).*/\1/p" # alpha
  bogomips := $(shell sed -n $(sedbogo) /proc/cpuinfo | head -1)
endif

ifeq (,$(bogomips))
  $(warning cannot run complexity tests (no bogomips found))
endif

log_success = "==========> SUCCESS <=========="
log_failure = "==========> FAILURE <=========="
log_intro = "==========> TESTING $(1) <=========="

#######################################################################
# Testing subsystems
#######################################################################

# Apart so that it can be easily skipped with overriding
COMPLEXITY := $(if $(bogomips),complexity)

BUGS := bugs/opened/shouldnotfail bugs/opened/shouldnotsucceed \
  bugs/closed/shouldsucceed bugs/closed/shouldfail

VSUBSYSTEMS := prerequisite success failure $(BUGS) output \
  interactive micromega $(COMPLEXITY) modules

# All subsystems
SUBSYSTEMS := $(VSUBSYSTEMS) misc bugs ide

#######################################################################
# Phony targets
#######################################################################

.DELETE_ON_ERROR:
.PHONY: all run clean $(SUBSYSTEMS)

all: run
	$(MAKE) --quiet summary.log

run: $(SUBSYSTEMS)
bugs: $(BUGS)

clean:
	rm -f trace lia.cache
	$(SHOW) "RM        <**/*.stamp> <**/*.vo> <**/*.log>"
	$(HIDE)find . \( \
	  -name '*.stamp' -o -name '*.vo' -o -name '*.log' \
	\) -print0 | xargs -0 rm -f

#######################################################################
# Per-subsystem targets
#######################################################################

define mkstamp
$(1): $(1).stamp ; @true
$(1).stamp: $(patsubst %.v,%.v.log,$(wildcard $(1)/*.v)) ; \
	$(HIDE)touch $$@
endef
$(foreach S,$(VSUBSYSTEMS),$(eval $(call mkstamp,$(S))))

#######################################################################
# Summary
#######################################################################

summary_dir = echo $(1); find $(2) -name '*.log' -print0 | xargs -0 -n 1 tail -n1 | sort -g

.PHONY: summary summary.log

summary:
	@{ \
	  $(call summary_dir, "Preparing tests", prerequisite); \
	  $(call summary_dir, "Success tests", success); \
	  $(call summary_dir, "Failure tests", failure); \
	  $(call summary_dir, "Bugs tests", bugs); \
	  $(call summary_dir, "Output tests", output); \
	  $(call summary_dir, "Interactive tests", interactive); \
	  $(call summary_dir, "Micromega tests", micromega); \
	  $(call summary_dir, "Miscellaneous tests", misc); \
	  $(call summary_dir, "Complexity tests", complexity); \
	  $(call summary_dir, "Module tests", modules); \
	  $(call summary_dir, "IDE tests", ide); \
	  nb_success=`find . -name '*.log' -exec tail -n2 '{}' \; | grep -e $(log_success) | wc -l`; \
	  nb_failure=`find . -name '*.log' -exec tail -n2 '{}' \; | grep -e $(log_failure) | wc -l`; \
	  nb_tests=`expr $$nb_success + $$nb_failure`; \
	  pourcentage=`expr 100 \* $$nb_success / $$nb_tests`; \
	  echo; \
	  echo "$$nb_success tests passed over $$nb_tests, i.e. $$pourcentage %"; \
	}

summary.log:
	$(SHOW) SUMMARY
	$(HIDE)$(MAKE) --quiet summary > "$@"

#######################################################################
# Regression (and progression) tests
#######################################################################

# Process verifications concerning submitted bugs. A message is
# printed for all opened bugs (still active or seems to be closed).
# For closed bugs that behave as expected, no message is printed

# All files are assumed to have <# of the bug>.v as a name

# Opened bugs that should not succeed (FIXME: there were no such tests
# at the time of writing this Makefile, but the possibility was in the
# original shellscript... so left it here, but untested)
$(addsuffix .log,$(wildcard bugs/opened/shouldnotsucceed/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  $(call test_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...still active"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be closed, please check)";
	  fi;
	} > "$@"

# Opened bugs that should not fail
$(addsuffix .log,$(wildcard bugs/opened/shouldnotfail/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R != 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...still active"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be closed, please check)"; \
	  fi; \
	} > "$@"

# Closed bugs that should succeed
$(addsuffix .log,$(wildcard bugs/closed/shouldsucceed/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be opened, please check)"; \
	  fi; \
	} > "$@"

# Closed bugs that should fail
$(addsuffix .log,$(wildcard bugs/closed/shouldfail/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R != 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be opened, please check)"; \
	  fi; \
	} > "$@"

#######################################################################
# Other generic tests
#######################################################################

$(addsuffix .log,$(wildcard prerequisite/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(coqc) "$*" 2>&1; R=$$?; times; \
	  if [ $$R != 0 ]; then \
	    echo $(log_failure); \
	    echo "    $<...could not be prepared" ; \
	  else \
	    echo $(log_success); \
	    echo "    $<...correctly prepared" ; \
	  fi; \
	} > "$@"

$(addsuffix .log,$(wildcard success/*.v micromega/*.v modules/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  opts="$(if $(findstring modules/,$<),-I modules -impredicative-set)"; \
	  echo $(call log_intro,$<); \
	  $(command) "$<" $$opts 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (should be accepted)"; \
	  fi; \
	} > "$@"

$(addsuffix .log,$(wildcard failure/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R != 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (should be rejected)"; \
	  fi; \
	} > "$@"

$(addsuffix .log,$(wildcard output/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  tmpoutput=`mktemp /tmp/coqcheck.XXXXXX`; \
	  $(command) "$<" 2>&1 \
	    | grep -v "Welcome to Coq" \
	    | grep -v "Skipping rcfile loading" \
	    > $$tmpoutput; \
	  diff -u $*.out $$tmpoutput 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (unexpected output)"; \
	  fi; \
	  rm $$tmpoutput; \
	} > "$@"

$(addsuffix .log,$(wildcard interactive/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(coqtop) < "$<" 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (should be accepted)"; \
	  fi; \
	} > "$@"

# Complexity test. Expects a line "(* Expected time < XXX.YYs *)" in
# the .v file with exactly two digits after the dot. The reference for
# time is a 6120 bogomips cpu.
ifneq (,$(bogomips))
$(addsuffix .log,$(wildcard complexity/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  true "extract effective user time"; \
	  res=`$(command) "$<" 2>&1 | sed -n -e "s/Finished transaction in .*(\([0-9]*\.[0-9]*\)u.*)/\1/p" | head -1`; \
	  R=$$?; times; \
	  if [ $$R != 0 ]; then \
	    echo $(log_failure); \
	    echo "    $<...Error! (should be accepted)" ; \
	  elif [ "$$res" = "" ]; then \
	    echo $(log_failure); \
	    echo "    $<...Error! (couldn't find a time measure)"; \
	  else \
	    true "express effective time in centiseconds"; \
	    res=`echo "$$res"00 | sed -n -e "s/\([0-9]*\)\.\([0-9][0-9]\).*/\1\2/p"`; \
	    true "find expected time * 100"; \
	    exp=`sed -n -e "s/(\*.*Expected time < \([0-9]\).\([0-9][0-9]\)s.*\*)/\1\2/p" "$<"`; \
	    ok=`expr \( $$res \* $(bogomips) \) "<" \( $$exp \* 6120 \)`; \
	    if [ "$$ok" = 1 ]; then \
	      echo $(log_success); \
	      echo "    $<...Ok"; \
	    else \
	      echo $(log_failure); \
	      echo "    $<...Error! (should run faster)"; \
	    fi; \
	  fi; \
	} > "$@"
endif

# Ideal-features tests
$(addsuffix .log,$(wildcard ideal-features/*.v)): %.v.log: %.v
	@echo "TEST      $<"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(command) "$<" 2>&1; R=$$?; times; \
	  if [ $$R != 0 ]; then \
	      echo $(log_success); \
	      echo "    $<...still wished"; \
          else \
	      echo $(log_failure); \
	      echo "    $<...Good news! (wish seems to be granted, please check)"; \
          fi; \
	} > "$@"

# Additionnal dependencies for module tests
$(addsuffix .log,$(wildcard modules/*.v)): %.v.log: modules/Nat.vo modules/plik.vo
%.vo: %.v
	$(HIDE)$(coqtop) -compile $*

#######################################################################
# Miscellaneous tests
#######################################################################

misc: misc/xml.log misc/deps-order.log misc/universes.log

# Test xml compilation
xml: misc/xml.log
misc/xml.log:
	@echo "TEST      misc/xml"
	$(HIDE){ \
	  echo $(call log_intro,xml); \

=== debian/changelog ===
coq-doc (8.4pl2-1) unstable; urgency=medium

  * New upstream release
  * Debhelper compat level 9
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Dec 2013 09:06:18 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>
 Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 8)
+Build-Depends: debhelper (>= 9)
 Build-Depends-Indep:
  texlive,
  texlive-base,
@@ -18,8 +18,8 @@
  camlp5,
  ocaml-nox
 Homepage: http://coq.inria.fr/
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/coq-doc.git
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/coq-doc.git
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/coq-doc.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/coq-doc.git
 
 Package: coq-doc
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Build cache (for accelerating Debian debugging)
BUILDCACHE := $(wildcard ../coq.cache)

%:
	dh $@

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure -local

.PHONY: override_dh_auto_build
override_dh_auto_build:
ifneq ($(BUILDCACHE),)
	rsync -a --exclude=debian --exclude=.git $(BUILDCACHE)/ .
endif
	$(MAKE) refman faq tutorial rectutorial

.PHONY: override_dh_auto_test
override_dh_auto_test:

.PHONY: override_dh_auto_install
override_dh_auto_install:

=== debian/watch ===
version=3

http://coq.inria.fr/download distrib/[^/]+/files/coq-(.*)\.tar\.gz

## coq-doc 8.4pl4

=== Makefile ===
#######################################################################
#  v      #   The Coq Proof Assistant  /  The Coq Development Team    #
# <O___,, #        INRIA-Rocquencourt  &  LRI-CNRS-osay              #
#   \VV/  #############################################################
#    //   #      This file is distributed under the terms of the      #
#         #       GNU Lesser General Public License Version 2.1       #
#######################################################################


# Makefile for Coq
#
# To be used with GNU Make >= 3.81.
#
# This Makefile is now separated into Makefile.{common,build,doc}.
# You won't find Makefiles in sub-directories and this is done on purpose.
# If you are not yet convinced of the advantages of a single Makefile, please
# read
#    http://miller.emu.id.au/pmiller/books/rmch/
# before complaining.
# 
# When you are working in a subdir, you can compile without moving to the
# upper directory using "make -C ..", and the output is still understood
# by Emacs' next-error.
#
# Specific command-line options to this Makefile:
#
# make VERBOSE=1           # restore the raw echoing of commands
# make NO_RECALC_DEPS=1    # avoid recomputing dependencies
# make NO_RECOMPILE_LIB=1  # a coqtop rebuild does not trigger a stdlib rebuild
#
# Nota: the 1 above can be replaced by any non-empty value
#
# ----------------------------------------------------------------------
# See dev/doc/build-system*.txt for more details/FAQ about this Makefile
# ----------------------------------------------------------------------


###########################################################################
# File lists
###########################################################################

# NB: due to limitations in Win32, please refrain using 'export' too much
# to communicate between make sub-calls (in Win32, 8kb max per env variable,
# 32kb total)

# !! Before using FIND_VCS_CLAUSE, please read how you should in the !!
# !! FIND_VCS_CLAUSE section of dev/doc/build-system.dev.txt         !!
FIND_VCS_CLAUSE:='(' \
  -name '{arch}' -o \
  -name '.svn' -o \
  -name '_darcs' -o \
  -name '.git' -o \
  -name '.bzr' -o \
  -name 'debian' -o \
  -name "$${GIT_DIR}" -o \
  -name '_build' \
')' -prune -o

define find
 $(shell find . $(FIND_VCS_CLAUSE) '(' -name $(1) ')' -print | sed 's|^\./||')
endef

## Files in the source tree

YACCFILES:=$(call find, '*.mly')
LEXFILES := $(call find, '*.mll')
export MLLIBFILES := $(call find, '*.mllib')
export ML4FILES := $(call find, '*.ml4')
export CFILES := $(call find, '*.c')

# NB: The lists of currently existing .ml and .mli files will change
# before and after a build or a make clean. Hence we do not export
# these variables, but cleaned-up versions (see below MLFILES and co)

EXISTINGML := $(call find, '*.ml')
EXISTINGMLI := $(call find, '*.mli')

## Files that will be generated

GENML4FILES:= $(ML4FILES:.ml4=.ml)
GENMLFILES:=$(LEXFILES:.mll=.ml) $(YACCFILES:.mly=.ml) \
  scripts/tolink.ml kernel/copcodes.ml
GENMLIFILES:=$(YACCFILES:.mly=.mli)
GENPLUGINSMOD:=$(filter plugins/%,$(MLLIBFILES:%.mllib=%_mod.ml))
export GENHFILES:=kernel/byterun/coq_jumptbl.h
export GENVFILES:=theories/Numbers/Natural/BigN/NMake_gen.v
export GENFILES:=$(GENMLFILES) $(GENMLIFILES) $(GENHFILES) $(GENVFILES) $(GENPLUGINSMOD)

# NB: all files in $(GENFILES) can be created initially, while
# .ml files in $(GENML4FILES) might need some intermediate building.
# That's why we keep $(GENML4FILES) out of $(GENFILES)

## More complex file lists

define diff
 $(strip $(foreach f, $(1), $(if $(filter $(f),$(2)),,$f)))
endef

export MLEXTRAFILES := $(GENMLFILES) $(GENML4FILES) $(GENPLUGINSMOD)
export MLSTATICFILES := $(call diff, $(EXISTINGML), $(MLEXTRAFILES))
export MLIFILES := $(sort $(GENMLIFILES) $(EXISTINGMLI))

include Makefile.common

###########################################################################
# Starting rules
###########################################################################

NOARG: world

.PHONY: NOARG help always

help:
	@echo "Please use either"
	@echo "   ./configure"
	@echo "   make world"
	@echo "   make install"
	@echo "   make clean"
	@echo "or make archclean"
	@echo
	@echo "For make to be verbose, add VERBOSE=1"

UNSAVED_FILES:=$(shell find . -name '.\#*v' -o -name '.\#*.ml' -o -name '.\#*.ml?')
ifdef UNSAVED_FILES
$(error You have unsaved changes in your editor (emacs?) [$(UNSAVED_FILES)]; \
cancel them or save before proceeding. Or your editor crashed. \
Then, you may want to consider whether you want to restore the autosaves)
#If you try to simply remove this explicit test, the compilation may
#fail later. In particular, if a .#*.v file exists, coqdep fails to
#run.
endif

# Apart from clean and tags, everything will be done in a sub-call to make
# on Makefile.build. This way, we avoid doing here the -include of .d :
# since they trigger some compilations, we do not want them for a mere clean

ifdef COQ_CONFIGURED
%:: always
	$(MAKE) --warn-undefined-variable --no-builtin-rules -f Makefile.build "$@"
else
%:: always
	@echo "Please run ./configure first" >&2; exit 1
endif

always : ;

# To speed-up things a bit, let's dissuade make to attempt rebuilding makefiles

Makefile Makefile.build Makefile.common config/Makefile : ;

###########################################################################
# Cleaning
###########################################################################

.PHONY: clean cleankeepvo objclean cruftclean indepclean doclean archclean optclean clean-ide ml4clean ml4depclean depclean cleanconfig distclean voclean devdocclean

clean: objclean cruftclean depclean docclean devdocclean

cleankeepvo: indepclean clean-ide optclean cruftclean depclean docclean devdocclean

objclean: archclean indepclean

cruftclean: ml4clean
	find . -name '*~' -o -name '*.annot' | xargs rm -f
	rm -f gmon.out core

indepclean:
	rm -f $(GENFILES)
	rm -f $(COQTOPBYTE) $(COQMKTOPBYTE) $(COQCBYTE) $(CHICKENBYTE) bin/fake_ide
	find . -name '*~' -o -name '*.cm[ioa]' | xargs rm -f
	rm -f */*.pp[iox] plugins/*/*.pp[iox]
	rm -rf $(SOURCEDOCDIR)
	rm -f toplevel/mltop.byteml toplevel/mltop.optml
	rm -f test-suite/check.log
	rm -f glob.dump
	rm -f config/revision.ml revision
	$(MAKE) -C test-suite clean

docclean:
	rm -f doc/*/*.dvi doc/*/*.aux doc/*/*.log doc/*/*.bbl doc/*/*.blg doc/*/*.toc \
	doc/*/*.idx doc/*/*~ doc/*/*.ilg doc/*/*.ind doc/*/*.dvi.gz doc/*/*.ps.gz doc/*/*.pdf.gz\
	doc/*/*.???idx doc/*/*.???ind doc/*/*.v.tex doc/*/*.atoc doc/*/*.lof\
	doc/*/*.hatoc doc/*/*.haux doc/*/*.hcomind doc/*/*.herrind doc/*/*.hidx doc/*/*.hind \
	doc/*/*.htacind doc/*/*.htoc doc/*/*.v.html
	rm -f doc/stdlib/index-list.html doc/stdlib/index-body.html \
	  doc/stdlib/*Library.coqdoc.tex doc/stdlib/library.files \
	  doc/stdlib/library.files.ls doc/stdlib/FullLibrary.tex
	rm -f doc/*/*.ps doc/*/*.pdf
	rm -rf doc/refman/html doc/stdlib/html doc/faq/html doc/tutorial/tutorial.v.html
	rm -f doc/refman/euclid.ml doc/refman/euclid.mli
	rm -f doc/refman/heapsort.ml doc/refman/heapsort.mli
	rm -f doc/common/version.tex
	rm -f doc/refman/styles.hva doc/refman/cover.html doc/refman/Reference-Manual.html
	rm -f doc/coq.tex
	rm -f doc/refman/styles.hva doc/refman/cover.html 

archclean: clean-ide optclean voclean
	rm -rf _build myocamlbuild_config.ml
	rm -f $(ALLSTDLIB).*

optclean:
	rm -f $(COQTOPEXE) $(COQMKTOP) $(COQC) $(CHICKEN) $(COQDEPBOOT)
	rm -f $(COQTOPOPT) $(COQMKTOPOPT) $(COQCOPT) $(CHICKENOPT)
	rm -f $(TOOLS) $(CSDPCERT)
	find . -name '*.cmx' -o -name '*.cmxs' -o -name '*.cmxa' -o -name '*.[soa]' -o -name '*.so' | xargs rm -f

clean-ide:
	rm -f $(COQIDECMO) $(COQIDECMX) $(COQIDECMO:.cmo=.cmi) $(COQIDEBYTE) $(COQIDEOPT) $(COQIDE)
	rm -f ide/input_method_lexer.ml
	rm -f ide/highlight.ml ide/config_lexer.ml ide/config_parser.mli ide/config_parser.ml
	rm -f ide/utf8_convert.ml

ml4clean:
	rm -f $(GENML4FILES)

ml4depclean:
	find . -name '*.ml4.d' | xargs rm -f

depclean:
	find . $(FIND_VCS_CLAUSE) '(' -name '*.d' ')' -print | xargs rm -f

cleanconfig:
	rm -f config/Makefile config/coq_config.ml dev/ocamldebug-v7 ide/undo.mli

distclean: clean cleanconfig

voclean:
	rm -f states/*.coq
	find theories plugins test-suite -name '*.vo' -o -name '*.glob' | xargs rm -f

devdocclean:
	find . -name '*.dep.ps' -o -name '*.dot' | xargs rm -f
	rm -f $(OCAMLDOCDIR)/*.log $(OCAMLDOCDIR)/*.aux $(OCAMLDOCDIR)/*.toc 
	rm -f $(OCAMLDOCDIR)/ocamldoc.sty $(OCAMLDOCDIR)/coq.tex 
	rm -f $(OCAMLDOCDIR)/html/*.html

###########################################################################
# Emacs tags
###########################################################################

.PHONY: tags otags

tags:
	echo $(MLIFILES) $(MLSTATICFILES) $(ML4FILES) | sort -r | xargs \
	etags --language=none\
	      "--regex=/let[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/let[ \t]+rec[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/and[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/type[ \t]+\([^ \t]+\)/\1/" \
              "--regex=/exception[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/val[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/module[ \t]+\([^ \t]+\)/\1/"
	echo $(ML4FILES) | sort -r | xargs \
	etags --append --language=none\
	      "--regex=/[ \t]*\([^: \t]+\)[ \t]*:/\1/"


otags: 
	echo $(MLIFILES) $(MLSTATICFILES) | sort -r | xargs otags
	echo $(ML4FILES) | sort -r | xargs \
	etags --append --language=none\
	      "--regex=/let[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/let[ \t]+rec[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/and[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/type[ \t]+\([^ \t]+\)/\1/" \
              "--regex=/exception[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/val[ \t]+\([^ \t]+\)/\1/" \
	      "--regex=/module[ \t]+\([^ \t]+\)/\1/"


%.elc: %.el
ifdef COQ_CONFIGURED
	echo "(setq load-path (cons \".\" load-path))" > $*.compile
	echo "(byte-compile-file \"$<\")" >> $*.compile
	- $(EMACS) -batch -l $*.compile
	rm -f $*.compile
else
	@echo "Please run ./configure first" >&2; exit 1
endif

# Useful to check that the exported variables are within the win32 limits

printenv:
	@env
	@echo
	@echo -n "Maxsize (win32 limit is 8k) : "
	@env | wc -L
	@echo -n "Total (win32 limit is 32k) : "
	@env | wc -m

=== debian/changelog ===
coq-doc (8.4pl4-2) unstable; urgency=medium

  * Team upload
  * patch unterminated_string_literal: fix FTBFS with ocaml 4.02.3
    (closes: #813063)

 -- Ralf Treinen <treinen@debian.org>  Thu, 11 Feb 2016 22:26:54 +0100

coq-doc (8.4pl4-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch
  * Put debian/copyright in format 1.0
  * Bump Standards-Version to 3.9.5

 -- Stéphane Glondu <glondu@debian.org>  Sun, 17 Aug 2014 14:36:07 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 9)
 Build-Depends-Indep:
  texlive,

=== debian/watch ===
version=3

http://coq.inria.fr/download .*/coq-(.*)\.tar\.gz
